import time #
import datetime #
from src.connection import connection_type as conn
import xlsxwriter
import os.path 

# Get date - 1
date = datetime.date.today() + datetime.timedelta(days=-3)

date2 = datetime.date.today()


# print(query)
ym = time.strftime("%Y-%m")
print(ym)

# print(datef)

while date < date2:
    datef =  date.strftime("%d-%B-%y")

    query = "select * from vw_w_Incentives_HDMM t where t.created_dt = '{}' ".format(datef)
    print(query)

    print(datef)
    
    try:
        # Get data to db
        connection = conn.connect_to_oracle_prod_2()
        # Get data to db
        curson = connection.cursor()
        data = curson.execute(query)
        
        data1 = curson.fetchall()

        FileData = r"C:\Users\F88\Google Drive\Data-incentives\Thưởng HĐMM {}.xlsx".format(date)
        if os.path.exists(FileData):
            os.remove(FileData)
        
        workbook =xlsxwriter.Workbook(FileData,{'default_date_format': 'dd/mm/yyyy', 'constant_memory': True})
        worksheet = workbook.add_worksheet("{}".format(ym))

        # Add a bold format to use to highlight cells.
        bold = workbook.add_format({'bold': 1})

        # Add a number format for cells with money.
        money_format = workbook.add_format({'num_format': '$#,##0'})

        # Add an Excel date format.
        date_format = workbook.add_format({'num_format': 'mmmm d yyyy'})

        # Adjust the column width.
        worksheet.set_column(1, 1, 30)

        # Write some data headers.
        worksheet.write(0,2,'Ma HD',bold)
        worksheet.write(0,3,'Ten PGD',bold)
        worksheet.write(0,4,'Loai TS',bold)
        worksheet.write(0,5,'Ngay vay',bold)
        worksheet.write(0,6,'Ngay het han',bold)
        worksheet.write(0,7,'Ngay dong HD',bold)
        worksheet.write(0,8,'Trang thai',bold)
        worksheet.write(0,9,'Goi vay',bold)
        worksheet.write(0,10,'Dong mo trong ngay',bold)
        worksheet.write(0,11,'KH cu/moi',bold)
        worksheet.write(0,12,'Shop_region',bold)
        worksheet.write(0,13,'Ma NV tao',bold)
        worksheet.write(0,14,'Ten NV tao',bold)
        worksheet.write(0,15,'Ma NV cham soc',bold)
        worksheet.write(0,16,'Ten NV cham soc',bold)
        worksheet.write(0,17,'Ma NV cham soc ban dau',bold)
        worksheet.write(0,18,'Ten NV cham soc ban dau',bold)
        worksheet.write(0,19,'Gia tri khoan vay',bold)
        worksheet.write(0,20,'Khoan vay HD ban dau',bold)
        worksheet.write(0,21,'Ngay',bold)

        # Start from the first cell below the headers.
        rowindex = 1
        col = 0

        for index in (data1):
            worksheet.write(rowindex,2,index[2])
            worksheet.write(rowindex,3,index[3])
            worksheet.write(rowindex,4,index[4])    
            worksheet.write(rowindex,5,index[5])
            worksheet.write(rowindex,6,index[6])
            worksheet.write(rowindex,7,index[7])
            worksheet.write(rowindex,8,index[8])
            worksheet.write(rowindex,9,index[9])
            worksheet.write(rowindex,10,index[10])
            worksheet.write(rowindex,11,index[11])
            worksheet.write(rowindex,12,index[12])
            worksheet.write(rowindex,13,index[13])
            worksheet.write(rowindex,14,index[14])
            worksheet.write(rowindex,15,index[15])
            worksheet.write(rowindex,16,index[16])
            worksheet.write(rowindex,17,index[17])
            worksheet.write(rowindex,18,index[18])
            worksheet.write(rowindex,19,index[19])
            worksheet.write(rowindex,20,index[20])
            worksheet.write(rowindex,21,index[21])
            
            rowindex += 1
        workbook.close()

    
        print("Insert Success khi da co file !")
        

    except Error as e :
        print("Lỗi",e)
    finally:
        connection.close()
    
    date = date + datetime.timedelta(days=+1)