from src.case.ggsheet.ggsheet_template import GGSheetETLTemplate


class ETL_INSURANCE_KPI(GGSheetETLTemplate):
    def __int__(self, sheet_name, data_row, col, year, month):
        self.sheet_name = sheet_name
        self.data_row = data_row
        self.col = col
        self.year = year
        self.month = month

    def delete_data(self):
        delete_data = "Delete from W_INS_KPI_D t where t.YEAR = {} and t.MONTH = {}".format(self.year, self.month)
        self.cursor.execute(delete_data)

    def get_data(self):
        self.data = self.source.to_dataframe(self.sheet_name, self.data_row, self.col)
        self.data = self.data.loc[
            (self.data['ShopID'] != '#N/A') & (self.data['Năm KPI'] == str(self.year)) &
            (self.data['Tháng KPI'] == str(self.month))]

    def insert_to_target(self):
        for index, row in self.data.iterrows():
            try:
                insert = "INSERT INTO W_AREA_MANAGER_D(SHOP_NAME,SHOP_CODE,GĐM,TPK,QLKV,TRADE_MKT,TRADE_LEAD,REGION,PROVINCE,FAIL_14_6,FAIL_18_5,OPEN_DT,TELESALE,STATUS,SHOP_ID,CLOSE_DT,FLAG,QLKV_USER_CODE)VALUES('{}','{}','{}','{}','{}','{}','{}','{}','{}','{}','{}','{}','{}','{}','{}','{}','{}','{}')".format(
                    row['PGD'], row['Mã PGD'], row['GĐM'], row['TPK'], row['QLKV'], row['Trade Marketing'],
                    row['Trade Leader'], row['Miền'], row['Tỉnh/ Thành phố'], row['Sự cố 14.6'], row['Sự cố 18.5'],
                    row['Tháng KT'], row['Telesales'], row['Trạng thái'], row['Shop ID'].replace(' ', ''),
                    row['Close_date'], row['Status'], row['QLKV_Code'])
                self.cursor.execute(insert)
            except Exception as err:
                print("Error_ETL_AREAR_MANAGE : ORACLE : '{}' ".format(err))
        print("Đồng bộ thành công : ETL_QL_KD")
