from abc import ABCMeta


class Singleton(object):
    __metaclass__ = ABCMeta
    instance = None

    def __new__(cls):
        if cls.instance is None:
            cls.instance = object.__new__(cls)
        return cls.instance

