from src.case.ggsheet.ggsheet_template import GGSheetETLTemplate


class ETL_QL_KD(GGSheetETLTemplate):
    def __init__(self, sheet_name, data_row, col):
        self.sheet_name = sheet_name
        self.data_row = data_row
        self.col = col

    def delete_data(self):
        delete_data = "Delete from W_AREA_MANAGER_D"
        self.cursor.execute(delete_data)

    def get_data(self):
        self.data = self.source.to_dataframe(self.sheet_name, self.data_row, self.col)

    def insert_to_target(self):
        # for row_count in range(0, self.data.shape[0]):
        #     # try:
        #     chunk = self.data.iloc[row_count:row_count + 1, :].values.tolist()
        #     self.cursor.executemany(
        #             "INSERT INTO W_AREA_MANAGER_D" + " (SHOP_NAME,SHOP_CODE,GĐM,TPK,QLKV,TRADE_MKT,TRADE_LEAD,REGION,"
        #                                              "PROVINCE,FAIL_14_6,FAIL_18_5,OPEN_DT,TELESALE,STATUS,SHOP_ID,CLOSE_DT"
        #                                              ",FLAG,QLKV_USER_CODE) values (:1,:2,:3,:4,:5, :6, :7, :8, :9, :10,"
        #                                              " :11, :12, :13, :14, 15, :16, :17, :18)",
        #             chunk)
        #     # except Exception as err:
        #     #     print("Error_ETL_AREAR_MANAGE : ORACLE : '{}' ".format(err))
        # print("Đồng bộ thành công : ETL_QL_KD")

        for index, row in self.data.iterrows():
            try:
                insert = "INSERT INTO W_AREA_MANAGER_D(SHOP_NAME,SHOP_CODE,GĐM,TPK,QLKV,TRADE_MKT,TRADE_LEAD,REGION,PROVINCE,FAIL_14_6,FAIL_18_5,OPEN_DT,TELESALE,STATUS,SHOP_ID,CLOSE_DT,FLAG,QLKV_USER_CODE)VALUES('{}','{}','{}','{}','{}','{}','{}','{}','{}','{}','{}','{}','{}','{}','{}','{}','{}','{}')".format(
                    row['PGD'], row['Mã PGD'], row['GĐM'], row['TPK'], row['QLKV'], row['Trade Marketing'],
                    row['Trade Leader'], row['Miền'], row['Tỉnh/ Thành phố'], row['Sự cố 14.6'], row['Sự cố 18.5'],
                    row['Tháng KT'], row['Telesales'], row['Trạng thái'], row['Shop ID'].replace(' ', ''),
                    row['Close_date'], row['Status'], row['QLKV_Code'])
                self.cursor.execute(insert)
            except Exception as err:
                print("Error_ETL_AREAR_MANAGE : ORACLE : '{}' ".format(err))
        print("Đồng bộ thành công : ETL_QL_KD")
