def ETL_STORE_SERIES(gg_connection, oracle_connection, sheet_name, data_row, col):
    """
    Insert Google Sheet to Oracle Table W_STORE_SERIES_D
    :param gg_connection:
    :param oracle_connection:
    :param sheet_name:
    :param data_row:
    :param col:
    :return:
    """
    # get data from google sheet to dataframe
    data = gg_connection.to_dataframe(sheet_name, data_row, col)
    print(data)
    # Oracle DWH new
    # truncate table
    oracle_cursor = oracle_connection.connection.cursor()
    delete_data = "Delete from w_store_series_d"
    oracle_cursor.execute(delete_data)
    for index, row in data.iterrows():
        try:
            script = "INSERT INTO W_STORE_SERIES_D(SHOP_NAME,SHOP_NAME_ACTIVE,GROUP_OPEN,OPEN_DT,DUMMY,REGION_," \
                     "LONG_,LAT, PROVINCE,AREAR,SHOP_AGE,OPEN_DATE,SHOP_WID) VALUES(N'{}' ,N'{}' ,N'{}' ,N'{}' ,'{}'" \
                     " ,N'{}' '{}','{}', N'{}', N'{}', '{}', '{}', '{}')".format(row[0], row[1], row['Nhóm'],
                                                                                 row['Tháng khai trương'], row['Dummy'],
                                                                                 row['Miền'], row['Longitude'],
                                                                                 row['Lattitude'],
                                                                                 row['Tỉnh thành phố'], row['Khu vực'],
                                                                                 row['Tuổi'], row['Khai trương'],
                                                                                 row['Shop ID'])
            oracle_cursor.execute(script)
        except Exception as err:
            print("Error_ETL_STORE_SERIES : ORACLE ", err)

    print("Đồng bộ thành công : ETL_STORE_SERIES")
    oracle_cursor.commit()
    oracle_connection.close()
